<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { CONTENT_TYPES } from '../../common/content-types';
import { partnerIndexService } from '../../services/partners/partner-index.service';

import { GetStartedResources } from '~/components/get-started/index.vue';
import {
  Benefits,
  CTA as CallToAction,
  FreeTrialCTA,
  NextStepAlt,
} from '~/components/common/index.vue';
import {
  PartnersCopyBlock as CopyBlock,
  FeaturedPartners,
  PartnersHero as Hero,
  PartnersIntro as Intro,
  PartnersShowcase,
  PartnersResources as Resources,
} from '~/components/partners/index.vue';
import { getPageMetadata } from '~/common/meta';
import { getClient } from '~/plugins/contentful.js';
import { FooterEditLinkMixin } from '~/mixins';

import { convertToCaseSensitiveLocale } from '~/common/util';

export default Vue.extend({
  components: {
    CallToAction,
    FeaturedPartners,
    Benefits,
    FreeTrialCTA,
    Intro,
    Hero,
    CopyBlock,
    GetStartedResources,
    NextStepAlt,
    PartnersShowcase,
    Resources,
  },
  mixins: [FooterEditLinkMixin],
  async asyncData({ i18n }) {
    try {
      const response = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'sys.id': '5PnX2OqKPuSTmLbhpxvHIE',
        include: 10,
        locale: convertToCaseSensitiveLocale(i18n.locale),
      });
      const spaceId = response.items[0].sys.space.sys.id;
      const entryId = response.items[0].sys.id;
      const { pageContent } = response.items[0].fields;
      const seoMetadata = response.items[0].fields.seoMetadata[0].fields;

      const partner = partnerIndexService(pageContent);

      const metadata = {
        title: seoMetadata.ogTitle,
        description: seoMetadata.ogDescription,
        og_title: seoMetadata.ogTitle,
        og_description: seoMetadata.ogDescription,
      };
      return { partner, metadata, spaceId, entryId };
    } catch (e) {
      throw new Error(e);
    }
  },

  head(): MetaInfo {
    return getPageMetadata(
      (this as any).metadata,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
});
</script>

<template>
  <section class="partners-container">
    <component
      :is="component.name"
      v-for="(component, index) in partner.components"
      :key="component.name + index"
      :data="component.data"
    />
    <NextStepAlt />
  </section>
</template>

<style lang="scss" scoped>
.partners-container {
  overflow-x: hidden;

  .container {
    margin-top: $spacing-96;
  }
}
</style>
